Bug 43265 - Inconsistency in Compilation of Async Code Compared to MSFT Compilers
Summary: Inconsistency in Compilation of Async Code Compared to MSFT Compilers
Status: RESOLVED FIXED
Alias: None
Product: Compilers
Classification: Mono
Component: C# (show other bugs)
Version: unspecified
Hardware: PC Mac OS
: --- normal
Target Milestone: ---
Assignee: Marek Safar
URL:
Depends on:
Blocks:
 
Reported: 2016-08-10 22:07 UTC by Dominic N [MSFT]
Modified: 2016-08-15 19:23 UTC (History)
3 users (show)

See Also:
Tags:
Is this bug a regression?: ---
Last known good build:


Attachments

Description Dominic N [MSFT] 2016-08-10 22:07:48 UTC
### Overview

A user has indicated they encountered an issue with the Mono compiler.

After some testing, examining stack trace and exception details, they've found an inconsistency in the way Mono compiles async code when compared with the Microsoft compilers.

In order to test this, they following method:

public async Task<RegistrationDetails> GetRegistrationDetailsAsync()
{
// Make sure to clone the details here.
return new RegistrationDetails
{
UserDetails = new UserDetails(await _registrationContext.GetUser()),
DeviceDetails = new DeviceDetails(await _registrationContext.GetDevice())
};
}

To this:

public async Task<RegistrationDetails> GetRegistrationDetailsAsync()
{
// Make sure to clone the details here.
var userDetails = await _registrationContext.GetUser();
var deviceDetails = await _registrationContext.GetDevice();
return new RegistrationDetails
{
UserDetails = new UserDetails(userDetails),
DeviceDetails = new DeviceDetails(deviceDetails)
};
}

With the original code, the user received a NRE when the method was called. Following this change to the latter code, the user no longer gets the NRE. They have indicated that they believe this to be a Xamarin -> Mono compiler issue as they have not seen this reported by other customer or within their own test applications (which use the precompiled assemblies included in their Nuget packages). They also indicate that this is not an issue with applications compiled directly from source on Windows machines using Visual Studio.
Comment 1 Marek Safar 2016-08-15 19:23:06 UTC
Fixed in master and Mono 4.6

Notice (2018-05-21): bugzilla.xamarin.com will be switching to read-only mode on Thursday, 2018-05-25 22:00 UTC.

Please join us on Visual Studio Developer Community and GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs and copy them to the new locations as needed for follow-up. The See Also field on each Bugzilla bug will be updated with a link to its new location when applicable.

After Bugzilla is read-only, if you have new information to add for a bug that does not yet have a matching issue on Developer Community or GitHub, you can create a follow-up issue in the new location. Copy and paste the title and description from this bug, and then add your new details. You can get a pre-formatted version of the title and description here:

In special cases you might also want the comments:

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.

Note You need to log in before you can comment on or make changes to this bug.